// actors are any non-inert stage element. these include baddies, powerups, and props.
// actors interact, such as via collision.

Punx.Sprite.Actor = function(args) {
    Punx.Sprite.call(this,args);

    this.name = args['name']||'Actor';

    this.collidable = true;

    this.busy = false; // set this to disable user input or to denote that a multi-cycle process is taking place and you dont want to be interrupted

    // get collided by another actor, react to it.
    // this is meant to be overloaded.
    // dont modify the other actor, as notification order is undefined. it's only provided for context so you can react appropriately.
    // chances are if its the initial collision then there will be a large swath of calls to this function within a short period of time, as
    // collisions are checked every screen update.
    // set flags etc accordingly to "debounce" collision notifications.
    // for example, when the player is collided by a baddy, inflict self-damage and set a flag and timeout for recover-time invulnerability.
    this.collide = function(actor) {
    };

    this.move = function(stage,direction,amount) {
        amount = amount || 5;
        this.setGroup(direction);
        var x = this.x;
        var y = this.y;
        switch (direction) {
            case 'left' : { x -= amount; break; }
            case 'right' : { x += amount; break; }
            case 'up' : { y -= amount; break; }
            case 'down' : { y += amount; break; }
        }
        if (!stage.clipping(this,x,y)) {
            this.x = x;
            this.y = y;
        }
        return true;
    }

}; Punx.Sprite.Actor.prototype = new Punx.Sprite();

