punx.entity = {};

/**
 * Entity can be collided by another entity.
 * @interface
 */
punx.entity.Collidable = function() {}:
punx.entity.Collidable.prototype.collide = function(entity) {};

/**
 * Entity is drawable.
 * @interface
 */
punx.entity.Drawable = function() {};
punx.entity.Drawable.prototype.draw = function(ctx,track) {};

/**
 * Screen inhabitants. Includes backgrounds, NPC, baddies, player, text, anything drawn or collidable.
 * @class
 */
punx.Entity = function(x,y) {

    this.x = x;
    this.y = y;
    this.v = 0;

    this.update = function() {
        var updated = false;
        for (var i in this.elements) {
            updated |= this.elements[i].update();
        }
        return updated;
    };

};
